// ◇ UTF-8

#ifndef __JNITEST_H__
#define __JNITEST_H__

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>

#include <jni.h>
#include <android/log.h>
#include <android/native_activity.h>
#include <android/configuration.h>
#include "android_native_app_glue.h"

// リリースビルドではLOGI以下のメッセージはログに表示しない
#ifdef NDEBUG
#undef LOGV_ENABLE
#undef LOGD_ENABLE
#undef LOGI_ENABLE
#define LOGV_ENABLE 0
#define LOGD_ENABLE 0
#define LOGI_ENABLE 0
#endif  // NDEBUG

// ログに表示する関数名
#define __MYFUNC__ __FUNCTION__
// #define __MYFUNC__ __func__

// ログ表示
#define  LOGV(...)  if (LOGV_ENABLE) {char tmp[1024]; sprintf(tmp, __VA_ARGS__); __android_log_print(ANDROID_LOG_VERBOSE, LOG_TAG, LOG_SUBTAG ": %s(): %s", __MYFUNC__, tmp);}
#define  LOGD(...)  if (LOGD_ENABLE) {char tmp[1024]; sprintf(tmp, __VA_ARGS__); __android_log_print(ANDROID_LOG_DEBUG  , LOG_TAG, LOG_SUBTAG ": %s(): %s", __MYFUNC__, tmp);}
#define  LOGI(...)  if (LOGI_ENABLE) {char tmp[1024]; sprintf(tmp, __VA_ARGS__); __android_log_print(ANDROID_LOG_INFO   , LOG_TAG, LOG_SUBTAG ": %s(): %s", __MYFUNC__, tmp);}
#define  LOGW(...)  if (1          ) {char tmp[1024]; sprintf(tmp, __VA_ARGS__); __android_log_print(ANDROID_LOG_WARN   , LOG_TAG, LOG_SUBTAG ": %s(): %s", __MYFUNC__, tmp);}
#define  LOGE(...)  if (1          ) {char tmp[1024]; sprintf(tmp, __VA_ARGS__); __android_log_print(ANDROID_LOG_ERROR  , LOG_TAG, LOG_SUBTAG ": %s(): %s", __MYFUNC__, tmp);}

// JNI関数名の作成
#define JNI_MAKEFUNCNAME2(a,b) a##_##b
#define JNI_MAKEFUNCNAME1(a,b) JNI_MAKEFUNCNAME2(a,b)
#define JNI_EXPORT_FUNCNAME(c) JNI_MAKEFUNCNAME1(JNI_MAKEFUNCNAME1(JNI_MAKEFUNCNAME1(Java,MY_JNI_EXPORT_PATH),MY_JNI_EXPORT_NAME),c)
#define JNI_IMPORT_FUNCNAME(c) JNI_MAKEFUNCNAME1(JNI_MAKEFUNCNAME1(JNI,MY_JNI_EXPORT_NAME),c)

#ifdef __cplusplus
extern "C" {
#endif


JNIEXPORT void JNICALL JNI_EXPORT_FUNCNAME(TestFunc)(
	JNIEnv *env,
	jclass clazz
);


#ifdef __cplusplus
}
#endif // __cplusplus

#endif  // __JNITEST_H__

// [EOF]
